/*===========================================================================*/
/*   (Foreign/cenum.scm)                                                     */
/*   Bigloo (2.1)                                                            */
/*   Manuel Serrano (c)       Mon Feb 7 20:45:59 CET 2000                    */
/*===========================================================================*/

/* GC selection */
#define THE_GC BOEHM_GC

/* debug mode */
#define BIGLOO_DEBUG 1

#include <bigloo2.1b.h>


/* Object type definitions */
typedef struct type
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t name;
     obj_t size;
     obj_t class;
     obj_t coerce_to_204;
     obj_t parents;
     bool_t init__47;
     bool_t magic__53;
     obj_t __57;
     obj_t alias;
     obj_t pointed_to_by_76;
     obj_t tvector;
     obj_t location;
  }
    *type_bglt;

typedef struct calias
  {
     bool_t array__248;
  }
      *calias_bglt;

typedef struct cenum
  {
     struct type *btype;
     obj_t literals;
  }
     *cenum_bglt;

typedef struct copaque
  {
     struct type *btype;
  }
       *copaque_bglt;

typedef struct cfunction
  {
     struct type *btype;
     long arity;
     struct type *type_res_48;
     obj_t type_args_244;
  }
         *cfunction_bglt;

typedef struct cptr
  {
     struct type *btype;
     struct type *point_to_164;
     bool_t array__248;
  }
    *cptr_bglt;

typedef struct cstruct
  {
     bool_t struct__46;
     obj_t fields;
     obj_t cstruct__170;
  }
       *cstruct_bglt;

typedef struct cstruct__170
  {
     struct type *btype;
     struct cstruct *cstruct;
  }
            *cstruct__170_bglt;

typedef struct ccomp
  {
     header_t header;
     obj_t widening;
     obj_t id;
     obj_t producer;
     obj_t consumer;
     obj_t finalizer;
     obj_t checksummer;
  }
     *ccomp_bglt;


static obj_t method_init_76_foreign_cenum();
extern obj_t symbol_append_197___r4_symbols_6_4(obj_t);
extern obj_t make_proto_inline_105_foreign_library(obj_t);
extern obj_t string_append(obj_t, obj_t);
extern obj_t type_type_type;
extern obj_t string_sans___40_type_tools(obj_t);
extern obj_t add_method__1___object(obj_t, obj_t, obj_t);
extern bool_t is_a__118___object(obj_t, obj_t);
extern obj_t module_initialization_70_foreign_cenum(long, char *);
extern obj_t module_initialization_70_tools_misc(long, char *);
extern obj_t module_initialization_70_type_tools(long, char *);
extern obj_t module_initialization_70_type_type(long, char *);
extern obj_t module_initialization_70_foreign_ctype(long, char *);
extern obj_t module_initialization_70_foreign_access(long, char *);
extern obj_t module_initialization_70_foreign_library(long, char *);
extern obj_t module_initialization_70_module_module(long, char *);
extern obj_t module_initialization_70___error(long, char *);
extern obj_t module_initialization_70___object(long, char *);
extern obj_t module_initialization_70___reader(long, char *);
extern obj_t module_initialization_70___r4_symbols_6_4(long, char *);
static obj_t imported_modules_init_94_foreign_cenum();
extern obj_t produce_module_clause__172_module_module(obj_t);
static obj_t library_modules_init_112_foreign_cenum();
extern obj_t register_foreign_access_idents__181_foreign_library(obj_t);
static obj_t toplevel_init_63_foreign_cenum();
extern obj_t open_input_string(obj_t);
extern obj_t cenum_foreign_ctype;
extern obj_t make_define_inline_245_foreign_library(obj_t, obj_t);
extern obj_t bigloo_type_error_location_103___error(obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t _4dots_199_tools_misc;
static bool_t cenum__97_foreign_cenum(obj_t);
static bool_t type__118_foreign_cenum(obj_t);
extern obj_t read___reader(obj_t);
static obj_t make_ctype_accesses__cenum1177_167_foreign_cenum(obj_t, obj_t, obj_t, obj_t);
static obj_t require_initialization_114_foreign_cenum = BUNSPEC;
static obj_t cnst_init_137_foreign_cenum();
static obj_t __cnst[27];

DEFINE_STATIC_PROCEDURE(proc1370_foreign_cenum, make_ctype_accesses__cenum1177_167_foreign_cenum1385, make_ctype_accesses__cenum1177_167_foreign_cenum, 0L, 3);
extern obj_t make_ctype_accesses__env_11_foreign_access;
DEFINE_STRING(string1379_foreign_cenum, string1379_foreign_cenum1386, "TYPE", 4);
DEFINE_STRING(string1380_foreign_cenum, string1380_foreign_cenum1387, "IMPORTED-MODULES-INIT PREDICATE-OF ::OBJ STATIC FOREIGN SYMBOL MACRO QUOTE FOREIGN-ID EQ? O FOREIGN? IF O::OBJ (PRAGMA::BOOL \"($1 == $2)\" O1 O2) O2 O1 ?::BOOL = PRAGMA - MAKE-CTYPE-ACCESSES!-CENUM1177 ::BOOL ? -> METHOD-INIT @FOREIGN_CENUM ", 240);
DEFINE_STRING(string1378_foreign_cenum, string1378_foreign_cenum1388, "CENUM", 5);
DEFINE_STRING(string1377_foreign_cenum, string1377_foreign_cenum1389, "cobj_to_foreign", 15);
DEFINE_STRING(string1376_foreign_cenum, string1376_foreign_cenum1390, "(", 1);
DEFINE_STRING(string1375_foreign_cenum, string1375_foreign_cenum1391, ")FOREIGN_TO_COBJ", 16);
DEFINE_STRING(string1374_foreign_cenum, string1374_foreign_cenum1392, "./Ieee/pair-list.scm", 20);
DEFINE_STRING(string1373_foreign_cenum, string1373_foreign_cenum1393, "PAIR", 4);
DEFINE_STRING(string1372_foreign_cenum, string1372_foreign_cenum1394, "/home/tahoe/serrano/prgm/project/bigloo/comptime/Foreign/cenum.scm", 66);
DEFINE_STRING(string1371_foreign_cenum, string1371_foreign_cenum1395, "BSTRING", 7);



/* module-initialization */
obj_t 
module_initialization_70_foreign_cenum(long checksum_827, char *from_828)
{
   AN_OBJECT;
   {
      if (
	 CBOOL(require_initialization_114_foreign_cenum))
	{
	   require_initialization_114_foreign_cenum =
	      BBOOL(((bool_t) 0));
	   library_modules_init_112_foreign_cenum();
	   cnst_init_137_foreign_cenum();
	   imported_modules_init_94_foreign_cenum();
	   method_init_76_foreign_cenum();
	   toplevel_init_63_foreign_cenum();
	   return BUNSPEC;
	}
      else
	{
	   return BUNSPEC;
	}
   }
}



/* library-modules-init */
obj_t 
library_modules_init_112_foreign_cenum()
{
   AN_OBJECT;
   {	/* Foreign/cenum.scm 14 */
      module_initialization_70___r4_symbols_6_4(((long) 0), "FOREIGN_CENUM");
      module_initialization_70___object(((long) 0), "FOREIGN_CENUM");
      module_initialization_70___error(((long) 0), "FOREIGN_CENUM");
      module_initialization_70___reader(((long) 0), "FOREIGN_CENUM");
      return BUNSPEC;
   }
}



/* cnst-init */
obj_t 
cnst_init_137_foreign_cenum()
{
   AN_OBJECT;
   {	/* Foreign/cenum.scm 14 */
      {		/* Foreign/cenum.scm 14 */
	 obj_t cnst_port_138_820;
	 cnst_port_138_820 =
	    open_input_string(string1380_foreign_cenum);
	 {
	    long i_821;
	    i_821 = ((long) 26);
	  loop_822:
	    {	/* Foreign/cenum.scm 14 */
	       bool_t test1381_823;
	       test1381_823 =
		  (i_821 == ((long) -1));
	       if (test1381_823)
		 {	/* Foreign/cenum.scm 14 */
		    return BUNSPEC;
		 }
	       else
		 {	/* Foreign/cenum.scm 14 */
		    {	/* Foreign/cenum.scm 14 */
		       obj_t arg1382_824;
		       {	/* Foreign/cenum.scm 14 */
			  obj_t list1383_825;
			  list1383_825 =
			     MAKE_PAIR(cnst_port_138_820, BNIL);
			  arg1382_824 =
			     read___reader(list1383_825);
		       }
		       CNST_TABLE_SET(i_821, arg1382_824);
		    }
		    {	/* Foreign/cenum.scm 14 */
		       int aux_826;
		       {	/* Foreign/cenum.scm 14 */
			  long aux_847;
			  aux_847 =
			     (i_821 - ((long) 1));
			  aux_826 =
			     (int) (aux_847);
		       }
		       {
			  long i_850;
			  i_850 =
			     (long) (aux_826);
			  i_821 = i_850;
			  goto loop_822;
		       }
		    }
		 }
	    }
	 }
      }
   }
}



/* toplevel-init */
obj_t 
toplevel_init_63_foreign_cenum()
{
   AN_OBJECT;
   {	/* Foreign/cenum.scm 14 */
      {		/* Foreign/cenum.scm 14 */
	 obj_t symbol1344_787;
	 symbol1344_787 =
	    CNST_TABLE_REF(((long) 0));
	 {	/* Foreign/cenum.scm 14 */

	    PUSH_TRACE(symbol1344_787);
	    BUNSPEC;
	    POP_TRACE();
	    return BUNSPEC;
	 }
      }
   }
}



/* cenum? */
bool_t 
cenum__97_foreign_cenum(obj_t obj_311)
{
   AN_OBJECT;
   {	/* ./Foreign/ctype.scm 32 */
      return
	 is_a__118___object(obj_311, cenum_foreign_ctype);
   }
}



/* type? */
bool_t 
type__118_foreign_cenum(obj_t obj_424)
{
   AN_OBJECT;
   {	/* ./Type/type.scm 18 */
      return
	 is_a__118___object(obj_424, type_type_type);
   }
}



/* method-init */
obj_t 
method_init_76_foreign_cenum()
{
   AN_OBJECT;
   {	/* Foreign/cenum.scm 14 */
      {		/* Foreign/cenum.scm 14 */
	 obj_t symbol1346_789;
	 symbol1346_789 =
	    CNST_TABLE_REF(((long) 1));
	 {	/* Foreign/cenum.scm 14 */

	    PUSH_TRACE(symbol1346_789);
	    BUNSPEC;
	    {	/* Foreign/cenum.scm 14 */
	       obj_t aux1345_790;
	       {	/* Foreign/cenum.scm 14 */
		  obj_t make_ctype_accesses__cenum1177_167_793;
		  make_ctype_accesses__cenum1177_167_793 = proc1370_foreign_cenum;
		  aux1345_790 =
		     add_method__1___object(make_ctype_accesses__env_11_foreign_access, cenum_foreign_ctype, make_ctype_accesses__cenum1177_167_793);
	       }
	       POP_TRACE();
	       return aux1345_790;
	    }
	 }
      }
   }
}



/* make-ctype-accesses!-cenum1177 */
obj_t 
make_ctype_accesses__cenum1177_167_foreign_cenum(obj_t env_794, obj_t what_795, obj_t who_796, obj_t loc_797)
{
   AN_OBJECT;
   {	/* Foreign/cenum.scm 26 */
      {
	 cenum_bglt what_566;
	 type_bglt who_567;
	 obj_t loc_568;
	 if (
	    cenum__97_foreign_cenum(what_795))
	   {	/* Foreign/cenum.scm 27 */
	      what_566 =
		 (cenum_bglt) (what_795);
	   }
	 else
	   {	/* Foreign/cenum.scm 27 */
	      bigloo_type_error_location_103___error(
		 CNST_TABLE_REF(((long) 5)), string1378_foreign_cenum, what_795, string1372_foreign_cenum,
		 BINT(((long) 1333)));
	      exit(-1);
	   }
	 if (
	    type__118_foreign_cenum(who_796))
	   {	/* Foreign/cenum.scm 27 */
	      who_567 =
		 (type_bglt) (who_796);
	   }
	 else
	   {	/* Foreign/cenum.scm 27 */
	      bigloo_type_error_location_103___error(
		 CNST_TABLE_REF(((long) 5)), string1379_foreign_cenum, who_796, string1372_foreign_cenum,
		 BINT(((long) 1333)));
	      exit(-1);
	   }
	 loc_568 = loc_797;
	 {	/* Foreign/cenum.scm 27 */
	    type_bglt btype_571;
	    {
	       obj_t aux_861;
	       {	/* ./Foreign/ctype.scm 34 */
		  object_bglt aux_862;
		  aux_862 =
		     (object_bglt) (what_566);
		  aux_861 =
		     OBJECT_WIDENING(aux_862);
	       }
	       btype_571 =
		  (((cenum_bglt) CREF(aux_861))->btype);
	    }
	    {	/* Foreign/cenum.scm 27 */
	       obj_t id_572;
	       id_572 =
		  (((type_bglt) CREF(who_567))->id);
	       {	/* Foreign/cenum.scm 28 */
		  obj_t wid_573;
		  {	/* Foreign/cenum.scm 29 */
		     type_bglt obj_775;
		     obj_775 =
			(type_bglt) (what_566);
		     wid_573 =
			(((type_bglt) CREF(obj_775))->id);
		  }
		  {	/* Foreign/cenum.scm 29 */
		     obj_t bid_574;
		     bid_574 =
			(((type_bglt) CREF(btype_571))->id);
		     {	/* Foreign/cenum.scm 30 */
			obj_t id__bid_132_575;
			{	/* Foreign/cenum.scm 31 */
			   obj_t list1338_727;
			   {	/* Foreign/cenum.scm 31 */
			      obj_t arg1339_728;
			      {		/* Foreign/cenum.scm 31 */
				 obj_t arg1340_729;
				 obj_t arg1341_730;
				 arg1340_729 =
				    CNST_TABLE_REF(((long) 2));
				 arg1341_730 =
				    MAKE_PAIR(bid_574, BNIL);
				 arg1339_728 =
				    MAKE_PAIR(arg1340_729, arg1341_730);
			      }
			      list1338_727 =
				 MAKE_PAIR(id_572, arg1339_728);
			   }
			   id__bid_132_575 =
			      symbol_append_197___r4_symbols_6_4(list1338_727);
			}
			{	/* Foreign/cenum.scm 31 */
			   obj_t bid__id_105_576;
			   {	/* Foreign/cenum.scm 32 */
			      obj_t list1334_723;
			      {		/* Foreign/cenum.scm 32 */
				 obj_t arg1335_724;
				 {	/* Foreign/cenum.scm 32 */
				    obj_t arg1336_725;
				    obj_t arg1337_726;
				    arg1336_725 =
				       CNST_TABLE_REF(((long) 2));
				    arg1337_726 =
				       MAKE_PAIR(id_572, BNIL);
				    arg1335_724 =
				       MAKE_PAIR(arg1336_725, arg1337_726);
				 }
				 list1334_723 =
				    MAKE_PAIR(bid_574, arg1335_724);
			      }
			      bid__id_105_576 =
				 symbol_append_197___r4_symbols_6_4(list1334_723);
			   }
			   {	/* Foreign/cenum.scm 32 */
			      obj_t bid__101_577;
			      {		/* Foreign/cenum.scm 33 */
				 obj_t list1332_721;
				 {	/* Foreign/cenum.scm 33 */
				    obj_t arg1333_722;
				    {	/* Foreign/cenum.scm 33 */
				       obj_t aux_880;
				       aux_880 =
					  CNST_TABLE_REF(((long) 3));
				       arg1333_722 =
					  MAKE_PAIR(aux_880, BNIL);
				    }
				    list1332_721 =
				       MAKE_PAIR(id_572, arg1333_722);
				 }
				 bid__101_577 =
				    symbol_append_197___r4_symbols_6_4(list1332_721);
			      }
			      {		/* Foreign/cenum.scm 33 */
				 obj_t bid__bool_159_578;
				 {	/* Foreign/cenum.scm 34 */
				    obj_t list1330_719;
				    {	/* Foreign/cenum.scm 34 */
				       obj_t arg1331_720;
				       {	/* Foreign/cenum.scm 34 */
					  obj_t aux_885;
					  aux_885 =
					     CNST_TABLE_REF(((long) 4));
					  arg1331_720 =
					     MAKE_PAIR(aux_885, BNIL);
				       }
				       list1330_719 =
					  MAKE_PAIR(bid__101_577, arg1331_720);
				    }
				    bid__bool_159_578 =
				       symbol_append_197___r4_symbols_6_4(list1330_719);
				 }
				 {	/* Foreign/cenum.scm 34 */
				    obj_t name_579;
				    name_579 =
				       (((type_bglt) CREF(who_567))->name);
				    {	/* Foreign/cenum.scm 35 */
				       obj_t name_sans___18_580;
				       {	/* Foreign/cenum.scm 36 */
					  obj_t aux_891;
					  if (
					     STRINGP(name_579))
					    {	/* Foreign/cenum.scm 36 */
					       aux_891 = name_579
						  ;
					    }
					  else
					    {	/* Foreign/cenum.scm 36 */
					       bigloo_type_error_location_103___error(
						  CNST_TABLE_REF(((long) 5)), string1371_foreign_cenum, name_579, string1372_foreign_cenum,
						  BINT(((long) 1704)));
					       exit(-1);
					    }
					  name_sans___18_580 =
					     string_sans___40_type_tools(aux_891);
				       }
				       {	/* Foreign/cenum.scm 36 */
					  obj_t literals_581;
					  {
					     obj_t aux_899;
					     {	/* ./Foreign/ctype.scm 36 */
						object_bglt aux_900;
						aux_900 =
						   (object_bglt) (what_566);
						aux_899 =
						   OBJECT_WIDENING(aux_900);
					     }
					     literals_581 =
						(((cenum_bglt) CREF(aux_899))->literals);
					  }
					  {	/* Foreign/cenum.scm 37 */

					     {

						{	/* Foreign/cenum.scm 91 */
						   obj_t arg1212_587;
						   {	/* Foreign/cenum.scm 91 */
						      obj_t list1215_590;
						      {		/* Foreign/cenum.scm 91 */
							 obj_t arg1216_591;
							 obj_t arg1217_592;
							 arg1216_591 =
							    CNST_TABLE_REF(((long) 8));
							 {	/* Foreign/cenum.scm 91 */
							    obj_t arg1218_593;
							    {	/* Foreign/cenum.scm 91 */
							       obj_t aux_905;
							       aux_905 =
								  CNST_TABLE_REF(((long) 3));
							       arg1218_593 =
								  MAKE_PAIR(aux_905, BNIL);
							    }
							    arg1217_592 =
							       MAKE_PAIR(id_572, arg1218_593);
							 }
							 list1215_590 =
							    MAKE_PAIR(arg1216_591, arg1217_592);
						      }
						      arg1212_587 =
							 symbol_append_197___r4_symbols_6_4(list1215_590);
						   }
						   {	/* Foreign/cenum.scm 89 */
						      obj_t list1213_588;
						      {		/* Foreign/cenum.scm 89 */
							 obj_t arg1214_589;
							 arg1214_589 =
							    MAKE_PAIR(arg1212_587, BNIL);
							 list1213_588 =
							    MAKE_PAIR(bid__101_577, arg1214_589);
						      }
						      register_foreign_access_idents__181_foreign_library(list1213_588);
						   }
						}
						{	/* Foreign/cenum.scm 94 */
						   obj_t arg1219_594;
						   {	/* Foreign/cenum.scm 94 */
						      obj_t arg1220_595;
						      obj_t arg1221_596;
						      arg1220_595 =
							 CNST_TABLE_REF(((long) 22));
						      {		/* Foreign/cenum.scm 94 */
							 obj_t arg1222_597;
							 obj_t arg1223_598;
							 {	/* Foreign/cenum.scm 43 */
							    obj_t arg1322_706;
							    obj_t arg1323_707;
							    arg1322_706 =
							       CNST_TABLE_REF(((long) 20));
							    {	/* Foreign/cenum.scm 43 */
							       obj_t arg1324_708;
							       {	/* Foreign/cenum.scm 43 */
								  obj_t arg1325_709;
								  {	/* Foreign/cenum.scm 43 */
								     obj_t arg1326_710;
								     obj_t arg1327_711;
								     {	/* Foreign/cenum.scm 43 */
									obj_t arg1328_712;
									obj_t arg1329_713;
									arg1328_712 =
									   CNST_TABLE_REF(((long) 21));
									arg1329_713 =
									   MAKE_PAIR(id_572, BNIL);
									arg1326_710 =
									   MAKE_PAIR(arg1328_712, arg1329_713);
								     }
								     arg1327_711 =
									MAKE_PAIR(string1377_foreign_cenum, BNIL);
								     arg1325_709 =
									MAKE_PAIR(arg1326_710, arg1327_711);
								  }
								  arg1324_708 =
								     MAKE_PAIR(id__bid_132_575, arg1325_709);
							       }
							       arg1323_707 =
								  MAKE_PAIR(bid_574, arg1324_708);
							    }
							    arg1222_597 =
							       MAKE_PAIR(arg1322_706, arg1323_707);
							 }
							 {	/* Foreign/cenum.scm 94 */
							    obj_t arg1224_599;
							    {	/* Foreign/cenum.scm 46 */
							       obj_t mname_696;
							       {	/* Foreign/cenum.scm 46 */
								  obj_t arg1320_704;
								  {	/* Foreign/cenum.scm 48 */
								     obj_t aux_924;
								     if (
									STRINGP(name_sans___18_580))
								       {	/* Foreign/cenum.scm 48 */
									  aux_924 = name_sans___18_580
									     ;
								       }
								     else
								       {	/* Foreign/cenum.scm 48 */
									  bigloo_type_error_location_103___error(
									     CNST_TABLE_REF(((long) 5)), string1371_foreign_cenum, name_sans___18_580, string1372_foreign_cenum,
									     BINT(((long) 2093)));
									  exit(-1);
								       }
								     arg1320_704 =
									string_append(aux_924, string1375_foreign_cenum);
								  }
								  mname_696 =
								     string_append(string1376_foreign_cenum, arg1320_704);
							       }
							       {	/* Foreign/cenum.scm 49 */
								  obj_t arg1313_697;
								  obj_t arg1314_698;
								  arg1313_697 =
								     CNST_TABLE_REF(((long) 20));
								  {	/* Foreign/cenum.scm 49 */
								     obj_t arg1315_699;
								     {	/* Foreign/cenum.scm 49 */
									obj_t arg1316_700;
									{	/* Foreign/cenum.scm 49 */
									   obj_t arg1317_701;
									   obj_t arg1318_702;
									   arg1317_701 =
									      MAKE_PAIR(bid_574, BNIL);
									   arg1318_702 =
									      MAKE_PAIR(mname_696, BNIL);
									   arg1316_700 =
									      MAKE_PAIR(arg1317_701, arg1318_702);
									}
									arg1315_699 =
									   MAKE_PAIR(bid__id_105_576, arg1316_700);
								     }
								     arg1314_698 =
									MAKE_PAIR(id_572, arg1315_699);
								  }
								  arg1224_599 =
								     MAKE_PAIR(arg1313_697, arg1314_698);
							       }
							    }
							    arg1223_598 =
							       MAKE_PAIR(arg1224_599, BNIL);
							 }
							 arg1221_596 =
							    MAKE_PAIR(arg1222_597, arg1223_598);
						      }
						      arg1219_594 =
							 MAKE_PAIR(arg1220_595, arg1221_596);
						   }
						   produce_module_clause__172_module_module(arg1219_594);
						}
						{	/* Foreign/cenum.scm 96 */
						   obj_t arg1226_601;
						   {	/* Foreign/cenum.scm 96 */
						      obj_t arg1227_602;
						      obj_t arg1228_603;
						      arg1227_602 =
							 CNST_TABLE_REF(((long) 23));
						      {		/* Foreign/cenum.scm 97 */
							 obj_t arg1229_604;
							 {	/* Foreign/cenum.scm 97 */
							    obj_t arg1231_606;
							    {	/* Foreign/cenum.scm 97 */
							       obj_t arg1232_607;
							       {	/* Foreign/cenum.scm 97 */
								  obj_t aux_945;
								  aux_945 =
								     CNST_TABLE_REF(((long) 24));
								  arg1232_607 =
								     MAKE_PAIR(aux_945, BNIL);
							       }
							       arg1231_606 =
								  MAKE_PAIR(bid__bool_159_578, arg1232_607);
							    }
							    arg1229_604 =
							       make_proto_inline_105_foreign_library(arg1231_606);
							 }
							 arg1228_603 =
							    MAKE_PAIR(arg1229_604, BNIL);
						      }
						      arg1226_601 =
							 MAKE_PAIR(arg1227_602, arg1228_603);
						   }
						   produce_module_clause__172_module_module(arg1226_601);
						}
						{	/* Foreign/cenum.scm 98 */
						   obj_t arg1233_608;
						   {	/* Foreign/cenum.scm 98 */
						      obj_t arg1234_609;
						      obj_t arg1235_610;
						      arg1234_609 =
							 CNST_TABLE_REF(((long) 7));
						      {		/* Foreign/cenum.scm 98 */
							 obj_t arg1236_611;
							 {	/* Foreign/cenum.scm 98 */
							    obj_t arg1238_613;
							    {	/* Foreign/cenum.scm 98 */
							       obj_t arg1239_614;
							       {	/* Foreign/cenum.scm 98 */
								  obj_t arg1241_616;
								  obj_t arg1242_617;
								  arg1241_616 =
								     CNST_TABLE_REF(((long) 25));
								  arg1242_617 =
								     MAKE_PAIR(wid_573, BNIL);
								  arg1239_614 =
								     MAKE_PAIR(arg1241_616, arg1242_617);
							       }
							       arg1238_613 =
								  MAKE_PAIR(arg1239_614, BNIL);
							    }
							    arg1236_611 =
							       MAKE_PAIR(bid__101_577, arg1238_613);
							 }
							 arg1235_610 =
							    MAKE_PAIR(arg1236_611, BNIL);
						      }
						      arg1233_608 =
							 MAKE_PAIR(arg1234_609, arg1235_610);
						   }
						   produce_module_clause__172_module_module(arg1233_608);
						}
						{	/* Foreign/cenum.scm 101 */
						   obj_t arg1243_618;
						   obj_t arg1244_619;
						   {	/* Foreign/cenum.scm 62 */
						      obj_t arg1270_653;
						      obj_t arg1271_654;
						      {		/* Foreign/cenum.scm 62 */
							 obj_t arg1272_655;
							 obj_t arg1273_656;
							 {	/* Foreign/cenum.scm 62 */
							    obj_t list1274_657;
							    {	/* Foreign/cenum.scm 62 */
							       obj_t arg1275_658;
							       obj_t arg1276_659;
							       arg1275_658 =
								  CNST_TABLE_REF(((long) 8));
							       {	/* Foreign/cenum.scm 62 */
								  obj_t arg1277_660;
								  {	/* Foreign/cenum.scm 62 */
								     obj_t aux_963;
								     aux_963 =
									CNST_TABLE_REF(((long) 9));
								     arg1277_660 =
									MAKE_PAIR(aux_963, BNIL);
								  }
								  arg1276_659 =
								     MAKE_PAIR(id_572, arg1277_660);
							       }
							       list1274_657 =
								  MAKE_PAIR(arg1275_658, arg1276_659);
							    }
							    arg1272_655 =
							       symbol_append_197___r4_symbols_6_4(list1274_657);
							 }
							 {	/* Foreign/cenum.scm 63 */
							    obj_t arg1278_661;
							    obj_t arg1279_662;
							    {	/* Foreign/cenum.scm 63 */
							       obj_t list1280_663;
							       {	/* Foreign/cenum.scm 63 */
								  obj_t arg1281_664;
								  obj_t arg1282_665;
								  arg1281_664 =
								     CNST_TABLE_REF(((long) 10));
								  {	/* Foreign/cenum.scm 63 */
								     obj_t arg1283_666;
								     arg1283_666 =
									MAKE_PAIR(id_572, BNIL);
								     arg1282_665 =
									MAKE_PAIR(_4dots_199_tools_misc, arg1283_666);
								  }
								  list1280_663 =
								     MAKE_PAIR(arg1281_664, arg1282_665);
							       }
							       arg1278_661 =
								  symbol_append_197___r4_symbols_6_4(list1280_663);
							    }
							    {	/* Foreign/cenum.scm 64 */
							       obj_t arg1284_667;
							       {	/* Foreign/cenum.scm 64 */
								  obj_t list1286_669;
								  {	/* Foreign/cenum.scm 64 */
								     obj_t arg1287_670;
								     obj_t arg1288_671;
								     arg1287_670 =
									CNST_TABLE_REF(((long) 11));
								     {	/* Foreign/cenum.scm 64 */
									obj_t arg1289_672;
									arg1289_672 =
									   MAKE_PAIR(id_572, BNIL);
									arg1288_671 =
									   MAKE_PAIR(_4dots_199_tools_misc, arg1289_672);
								     }
								     list1286_669 =
									MAKE_PAIR(arg1287_670, arg1288_671);
								  }
								  arg1284_667 =
								     symbol_append_197___r4_symbols_6_4(list1286_669);
							       }
							       arg1279_662 =
								  MAKE_PAIR(arg1284_667, BNIL);
							    }
							    arg1273_656 =
							       MAKE_PAIR(arg1278_661, arg1279_662);
							 }
							 arg1270_653 =
							    MAKE_PAIR(arg1272_655, arg1273_656);
						      }
						      arg1271_654 =
							 CNST_TABLE_REF(((long) 12));
						      arg1243_618 =
							 make_define_inline_245_foreign_library(arg1270_653, arg1271_654);
						   }
						   {	/* Foreign/cenum.scm 101 */
						      obj_t arg1245_620;
						      obj_t arg1246_621;
						      {		/* Foreign/cenum.scm 54 */
							 obj_t arg1291_674;
							 obj_t arg1292_675;
							 {	/* Foreign/cenum.scm 54 */
							    obj_t arg1293_676;
							    {	/* Foreign/cenum.scm 54 */
							       obj_t aux_984;
							       aux_984 =
								  CNST_TABLE_REF(((long) 13));
							       arg1293_676 =
								  MAKE_PAIR(aux_984, BNIL);
							    }
							    arg1291_674 =
							       MAKE_PAIR(bid__bool_159_578, arg1293_676);
							 }
							 {	/* Foreign/cenum.scm 55 */
							    obj_t arg1294_677;
							    obj_t arg1295_678;
							    arg1294_677 =
							       CNST_TABLE_REF(((long) 14));
							    {	/* Foreign/cenum.scm 55 */
							       obj_t arg1296_679;
							       obj_t arg1297_680;
							       {	/* Foreign/cenum.scm 55 */
								  obj_t arg1298_681;
								  obj_t arg1299_682;
								  arg1298_681 =
								     CNST_TABLE_REF(((long) 15));
								  {	/* Foreign/cenum.scm 55 */
								     obj_t aux_990;
								     aux_990 =
									CNST_TABLE_REF(((long) 16));
								     arg1299_682 =
									MAKE_PAIR(aux_990, BNIL);
								  }
								  arg1296_679 =
								     MAKE_PAIR(arg1298_681, arg1299_682);
							       }
							       {	/* Foreign/cenum.scm 56 */
								  obj_t arg1300_683;
								  obj_t arg1301_684;
								  {	/* Foreign/cenum.scm 56 */
								     obj_t arg1302_685;
								     obj_t arg1303_686;
								     arg1302_685 =
									CNST_TABLE_REF(((long) 17));
								     {	/* Foreign/cenum.scm 56 */
									obj_t arg1304_687;
									obj_t arg1305_688;
									{	/* Foreign/cenum.scm 56 */
									   obj_t arg1306_689;
									   obj_t arg1307_690;
									   arg1306_689 =
									      CNST_TABLE_REF(((long) 18));
									   {	/* Foreign/cenum.scm 56 */
									      obj_t aux_996;
									      aux_996 =
										 CNST_TABLE_REF(((long) 16));
									      arg1307_690 =
										 MAKE_PAIR(aux_996, BNIL);
									   }
									   arg1304_687 =
									      MAKE_PAIR(arg1306_689, arg1307_690);
									}
									{	/* Foreign/cenum.scm 56 */
									   obj_t arg1308_691;
									   {	/* Foreign/cenum.scm 56 */
									      obj_t arg1310_693;
									      obj_t arg1311_694;
									      arg1310_693 =
										 CNST_TABLE_REF(((long) 19));
									      arg1311_694 =
										 MAKE_PAIR(bid_574, BNIL);
									      arg1308_691 =
										 MAKE_PAIR(arg1310_693, arg1311_694);
									   }
									   arg1305_688 =
									      MAKE_PAIR(arg1308_691, BNIL);
									}
									arg1303_686 =
									   MAKE_PAIR(arg1304_687, arg1305_688);
								     }
								     arg1300_683 =
									MAKE_PAIR(arg1302_685, arg1303_686);
								  }
								  arg1301_684 =
								     MAKE_PAIR(BFALSE, BNIL);
								  arg1297_680 =
								     MAKE_PAIR(arg1300_683, arg1301_684);
							       }
							       arg1295_678 =
								  MAKE_PAIR(arg1296_679, arg1297_680);
							    }
							    arg1292_675 =
							       MAKE_PAIR(arg1294_677, arg1295_678);
							 }
							 arg1245_620 =
							    make_define_inline_245_foreign_library(arg1291_674, arg1292_675);
						      }
						      {
							 obj_t literals_623;
							 obj_t res_624;
							 literals_623 = literals_581;
							 res_624 = BNIL;
						       loop_625:
							 if (
							    NULLP(literals_623))
							   {	/* Foreign/cenum.scm 71 */
							      arg1246_621 = res_624;
							   }
							 else
							   {	/* Foreign/cenum.scm 73 */
							      obj_t literal_627;
							      {		/* Foreign/cenum.scm 73 */
								 obj_t pair_780;
								 if (
								    PAIRP(literals_623))
								   {	/* Foreign/cenum.scm 73 */
								      pair_780 = literals_623;
								   }
								 else
								   {	/* Foreign/cenum.scm 73 */
								      bigloo_type_error_location_103___error(
									 CNST_TABLE_REF(((long) 5)), string1373_foreign_cenum, literals_623, string1372_foreign_cenum,
									 BINT(((long) 2767)));
								      exit(-1);
								   }
								 literal_627 =
								    CAR(pair_780);
							      }
							      {		/* Foreign/cenum.scm 73 */
								 obj_t literal_id_181_628;
								 {	/* Foreign/cenum.scm 74 */
								    obj_t pair_781;
								    if (
								       PAIRP(literal_627))
								      {		/* Foreign/cenum.scm 74 */
									 pair_781 = literal_627;
								      }
								    else
								      {		/* Foreign/cenum.scm 74 */
									 bigloo_type_error_location_103___error(
									    CNST_TABLE_REF(((long) 5)), string1373_foreign_cenum, literal_627, string1372_foreign_cenum,
									    BINT(((long) 2806)));
									 exit(-1);
								      }
								    literal_id_181_628 =
								       CAR(pair_781);
								 }
								 {	/* Foreign/cenum.scm 74 */
								    obj_t literal_name_176_629;
								    {	/* Foreign/cenum.scm 75 */
								       obj_t pair_782;
								       if (
									  PAIRP(literal_627))
									 {	/* Foreign/cenum.scm 75 */
									    pair_782 = literal_627;
									 }
								       else
									 {	/* Foreign/cenum.scm 75 */
									    bigloo_type_error_location_103___error(
									       CNST_TABLE_REF(((long) 5)), string1373_foreign_cenum, literal_627, string1372_foreign_cenum,
									       BINT(((long) 2845)));
									    exit(-1);
									 }
								       {	/* ./Ieee/pair-list.scm 202 */
									  obj_t arg1136_783;
									  arg1136_783 =
									     CDR(pair_782);
									  {	/* ./Ieee/pair-list.scm 202 */
									     obj_t pair_785;
									     if (
										PAIRP(arg1136_783))
									       {	/* ./Ieee/pair-list.scm 202 */
										  pair_785 = arg1136_783;
									       }
									     else
									       {	/* ./Ieee/pair-list.scm 202 */
										  bigloo_type_error_location_103___error(
										     CNST_TABLE_REF(((long) 5)), string1373_foreign_cenum, arg1136_783, string1374_foreign_cenum,
										     BINT(((long) 9004)));
										  exit(-1);
									       }
									     literal_name_176_629 =
										CAR(pair_785);
									  }
								       }
								    }
								    {	/* Foreign/cenum.scm 75 */
								       obj_t access_id_43_630;
								       {	/* Foreign/cenum.scm 76 */
									  obj_t list1265_648;
									  {	/* Foreign/cenum.scm 76 */
									     obj_t arg1266_649;
									     {	/* Foreign/cenum.scm 76 */
										obj_t arg1267_650;
										obj_t arg1268_651;
										arg1267_650 =
										   CNST_TABLE_REF(((long) 6));
										arg1268_651 =
										   MAKE_PAIR(literal_id_181_628, BNIL);
										arg1266_649 =
										   MAKE_PAIR(arg1267_650, arg1268_651);
									     }
									     list1265_648 =
										MAKE_PAIR(id_572, arg1266_649);
									  }
									  access_id_43_630 =
									     symbol_append_197___r4_symbols_6_4(list1265_648);
								       }
								       {	/* Foreign/cenum.scm 76 */
									  obj_t access_631;
									  {	/* Foreign/cenum.scm 78 */
									     obj_t arg1252_635;
									     obj_t arg1253_636;
									     {	/* Foreign/cenum.scm 78 */
										obj_t arg1254_637;
										{	/* Foreign/cenum.scm 78 */
										   obj_t list1256_639;
										   {	/* Foreign/cenum.scm 78 */
										      obj_t arg1257_640;
										      {		/* Foreign/cenum.scm 78 */
											 obj_t arg1258_641;
											 arg1258_641 =
											    MAKE_PAIR(wid_573, BNIL);
											 arg1257_640 =
											    MAKE_PAIR(_4dots_199_tools_misc, arg1258_641);
										      }
										      list1256_639 =
											 MAKE_PAIR(access_id_43_630, arg1257_640);
										   }
										   arg1254_637 =
										      symbol_append_197___r4_symbols_6_4(list1256_639);
										}
										arg1252_635 =
										   MAKE_PAIR(arg1254_637, BNIL);
									     }
									     {	/* Foreign/cenum.scm 82 */
										obj_t arg1259_642;
										obj_t arg1260_643;
										{	/* Foreign/cenum.scm 82 */
										   obj_t list1261_644;
										   {	/* Foreign/cenum.scm 82 */
										      obj_t arg1262_645;
										      obj_t arg1263_646;
										      arg1262_645 =
											 CNST_TABLE_REF(((long) 7));
										      {		/* Foreign/cenum.scm 82 */
											 obj_t arg1264_647;
											 arg1264_647 =
											    MAKE_PAIR(wid_573, BNIL);
											 arg1263_646 =
											    MAKE_PAIR(_4dots_199_tools_misc, arg1264_647);
										      }
										      list1261_644 =
											 MAKE_PAIR(arg1262_645, arg1263_646);
										   }
										   arg1259_642 =
										      symbol_append_197___r4_symbols_6_4(list1261_644);
										}
										arg1260_643 =
										   MAKE_PAIR(literal_name_176_629, BNIL);
										arg1253_636 =
										   MAKE_PAIR(arg1259_642, arg1260_643);
									     }
									     access_631 =
										make_define_inline_245_foreign_library(arg1252_635, arg1253_636);
									  }
									  {	/* Foreign/cenum.scm 77 */

									     {	/* Foreign/cenum.scm 84 */
										obj_t list1249_632;
										list1249_632 =
										   MAKE_PAIR(access_id_43_630, BNIL);
										register_foreign_access_idents__181_foreign_library(list1249_632);
									     }
									     {	/* Foreign/cenum.scm 85 */
										obj_t arg1250_633;
										obj_t arg1251_634;
										{	/* Foreign/cenum.scm 85 */
										   obj_t pair_786;
										   if (
										      PAIRP(literals_623))
										     {	/* Foreign/cenum.scm 85 */
											pair_786 = literals_623;
										     }
										   else
										     {	/* Foreign/cenum.scm 85 */
											bigloo_type_error_location_103___error(
											   CNST_TABLE_REF(((long) 5)), string1373_foreign_cenum, literals_623, string1372_foreign_cenum,
											   BINT(((long) 3161)));
											exit(-1);
										     }
										   arg1250_633 =
										      CDR(pair_786);
										}
										arg1251_634 =
										   MAKE_PAIR(access_631, res_624);
										{
										   obj_t res_1070;
										   obj_t literals_1069;
										   literals_1069 = arg1250_633;
										   res_1070 = arg1251_634;
										   res_624 = res_1070;
										   literals_623 = literals_1069;
										   goto loop_625;
										}
									     }
									  }
								       }
								    }
								 }
							      }
							   }
						      }
						      arg1244_619 =
							 MAKE_PAIR(arg1245_620, arg1246_621);
						   }
						   return
						      MAKE_PAIR(arg1243_618, arg1244_619);
						}
					     }
					  }
				       }
				    }
				 }
			      }
			   }
			}
		     }
		  }
	       }
	    }
	 }
      }
   }
}



/* imported-modules-init */
obj_t 
imported_modules_init_94_foreign_cenum()
{
   AN_OBJECT;
   {	/* Foreign/cenum.scm 14 */
      {		/* Foreign/cenum.scm 14 */
	 obj_t symbol1348_791;
	 symbol1348_791 =
	    CNST_TABLE_REF(((long) 26));
	 {	/* Foreign/cenum.scm 14 */

	    PUSH_TRACE(symbol1348_791);
	    BUNSPEC;
	    {	/* Foreign/cenum.scm 14 */
	       obj_t aux1347_792;
	       module_initialization_70_tools_misc(((long) 728), "FOREIGN_CENUM");
	       module_initialization_70_type_tools(((long) 35517), "FOREIGN_CENUM");
	       module_initialization_70_type_type(((long) 42396), "FOREIGN_CENUM");
	       module_initialization_70_foreign_ctype(((long) 404645), "FOREIGN_CENUM");
	       module_initialization_70_foreign_access(((long) 57817), "FOREIGN_CENUM");
	       module_initialization_70_foreign_library(((long) -50940), "FOREIGN_CENUM");
	       aux1347_792 =
		  module_initialization_70_module_module(((long) 49129), "FOREIGN_CENUM");
	       POP_TRACE();
	       return aux1347_792;
	    }
	 }
      }
   }
}
