(module appel-postgres
   (library pgbgl)
   (main call-post)
   )

(define *Print-Options*
   (let ((HEADER 1)
	 (NO_HEADER 0)
	 (ALIGN 1)
	 (NO_ALIGN 0)
	 (STANDARD 1)
	 (NO_STANDARD 0)
	 (HTML3 1)
	 (NO_HTML3 0)
	 (EXPANDED 1)
	 (NO_EXPANDED 0)
	 (PAGER 1)
	 (NO_PAGER 0)
	 (FIELD_SEPARATOR "|")
	 (HTML_TABLE_OPTIONS "")
	 (HTML_CAPTION "")
	 (FIELD_NAME (let ((opt (make-vector 1)))
			(vector-set! opt 0 "toto")
			opt)))
   (pgbgl:set-print-options! HEADER
			     ALIGN
			     NO_STANDARD
			     NO_HTML3
			     NO_EXPANDED
			     PAGER
			     "|" ;; field separator
			     ""  ;; options <table ...>
			     ""  ;; HTML caption
			     FIELD_NAME)))

(define (call-post argl)
   (let* ((query-name
	   (if (null? (cdr argl))
	       ";"
	       (string-append "where name = '"
			      (cadr argl)
			      "';")))
	  (pgLogin "bloch")
	  (dbName   "ma_base_pasteur")
	  (p-conn (pgbgl:connectdb (string-append
				     "dbname=" dbName
				     " user=" pgLogin))))
;     (pgbgl:trace p-conn (current-output-port))
      (print "a dmarre !")
      (print (pgbgl:db p-conn))
;     (print (pgbgl:status p-conn))
      (print (pgbgl:errorMessage p-conn))
      (let ((res (pgbgl:exec
		  p-conn (string-append
			  "SELECT * FROM persons "
			  query-name))))
	 (pgbgl:print
	  (current-output-port)
	  res
	  *Print-Options*)
	 (pgbgl:clear res)
	 (pgbgl:finish p-conn)
	 (print "c'est fini !"))))

